// seite geladen
$( document ).ready(function() {
	initGesamtpreis();
});

$(document).on('evo:loaded.io.request', function (event, data) {
    if (data.req.name === 'checkVarkombiDependencies') {
        initGesamtpreis();
    }
});


// für die varkombis
$( document ).ready(function() {
	var observer = new MutationObserver(function(mutations) {
			mutations.forEach(function(mutation) {
			//console.log('Mutation type: ' + mutation.type);
			if ( mutation.type == 'childList' ) {
				if (mutation.addedNodes.length >= 1) {
					//console.log(mutation.addedNodes[0]);
					if (mutation.addedNodes[0].id == 'result-wrapper') {
						initGesamtpreis();
						//console.log('Added ' + mutation.addedNodes[0].tagName + ' tag.');
			        	//console.log(mutation.addedNodes[0]);
			        	//console.log(mutation.addedNodes[0].id);
			        }
				} else if (mutation.removedNodes.length >= 1) {
					//console.log('Removed ' + mutation.removedNodes[0].tagName + ' tag.');
			        //console.log(mutation.removedNodes[0]);
				}
			} else if (mutation.type == 'attributes') {
				//console.log('Modified ' + mutation.attributeName + ' attribute.')
			}
		});   
	});
		  
	var observerConfig = {
		attributes: false,
		childList: true,
		characterData: false
	};
		  
	// Listen to all changes to body and child nodes
	var targetNode = $('#content')[0];
	observer.observe(targetNode, observerConfig);
});

// breite des dom elements ermitteln, wenn parent hidden
$.fn.getRealDimensions = function (outer) {
    var $this = $(this);
    if ($this.length == 0) {
        return false;
    }
    var $clone = $this.clone()
        .show()
        .css('visibility','hidden')
        .insertAfter($this);        
    var result = {
        width:      (outer) ? $clone.outerWidth() : $clone.innerWidth(), 
        height:     (outer) ? $clone.outerHeight() : $clone.innerHeight(), 
        offsetTop:  $clone.offset().top, 
        offsetLeft: $clone.offset().left
    };
    $clone.remove();
    return result;
}

// input feld geändert
$(document).on('change keyup paste', '#add-to-cart #quantity', function(el) {
	var mindestabnahme = parseInt($('#add-to-cart #quantity').data('min')),
		intervall = parseInt($('#add-to-cart #quantity').data('int')),
		livecalc = parseInt($('#buy_form').data('livecalc')),
		error = false;
	console.log('Menge manuell geaendert: ' + $(el.target).val() + '; Mindestabnahme: ' + mindestabnahme);
	if (!isNaN(mindestabnahme) || !isNaN(intervall)) {
		var delay = 650;
		setTimeout(function() {
			console.log('mindestabnahme: ' + mindestabnahme);
			if (!isNaN(mindestabnahme)) {
				if ($(el.target).val() < mindestabnahme) {
					$(el.target).val(mindestabnahme);
					errorMindestabnahme();
					error = true;
				}
			}

			console.log('intervall: ' + intervall);
			if (!isNaN(intervall)) {
				var rest = $(el.target).val() % intervall;
				console.log('Rest: ' + rest);
				if (rest > 0) {
					$(el.target).val($(el.target).val() - rest);
					errorMindestabnahme();
					error = true;
				}
			}
		}, delay);
	} 

	if (livecalc == 1 && error === false) {
		calcGesamtpreis();
	}
});

// error Mindestabnahme
function errorMindestabnahme() {
	$(document).find('.purchase-info').addClass('alert-danger').removeClass('alert-info');
	var delay = 1000;
	setTimeout(function() {
		$(document).find('.purchase-info').addClass('alert-info').removeClass('alert-danger');
	}, delay);
}

/*
// variation eingegeben
$(document).on('change', '.variation input', function() {
	var delay = 1500;
	setTimeout(function() {
		initGesamtpreis();
	}, delay);
});

// varianten aus select
$(document).on('change', '.variations select', function() {
	var delay = 1500;
	setTimeout(function() {
		initGesamtpreis();
	}, delay);
});
*/
// gesamtpreis ermitteln
function calcGesamtpreis() {
	var livecalc = parseInt($(document).find('#buy_form').data('livecalc')),
		cssprice = $(document).find('#buy_form').data('css-price'),
		cssprice1 = $(document).find('#buy_form').data('css-price1'),
		cssbulkprice = $(document).find('#buy_form').data('css-bulkprice'),
		cssqty = $(document).find('#buy_form').data('css-qty')
		;

	if (livecalc === 1) {
		var price = $(document).find(cssprice).text().trim(),
			price1 = $(document).find(cssprice).siblings(cssprice1).text().trim().replace('(','').replace(')','')
			qty = parseFloat($(document).find('#quantity').val()),
			tax = parseInt($(document).find('#quantity').data('tax')),
			taxFaktor = 1 + (tax / 100),
			istNetto = parseInt($(document).find('#quantity').data('ist-netto')),
			trueNetto = parseInt($(document).find('#quantity').data('true-netto')),
			trueNettoWert = parseFloat($(document).find('#quantity').data('true-netto-wert')),
			trueNettoCurrency = $(document).find('#quantity').data('true-netto-currency'),
			mindestabnahme = parseInt($(document).find('#quantity').data('min')),
			bulkPrice_arr = $(document).find(cssbulkprice + ' > table > tbody > tr'),
			tmpPrice = null,
			tmpPrice1 = null,
			tmpPriceCalc1 = null,
			priceCalc = null,
			priceCalc1 = null,
			bulkPrice = null,
			bulkPrice1 = null,
			bulkPriceTmp = null,
			bulkPriceTmp1 = null,
			price_arr = null,
			price_arr1 = null,
			priceString = '',
			priceString1 = '',
			pricePrefix = '',
			gesamtpreis = null,
			gesamtpreis1 = null,
			gesamtpreisString = null,
			gesamtpreisString1 = null,
			success = false,
			textBretto = $(document).find('#buy_form').data('bretto-text')
			;

		console.log('qty: ' + qty);

		console.log('Bulk Prices:');
		console.log(bulkPrice_arr);

		console.log('Price: ' + price);
		console.log('Price1: ' + price1);

		if (typeof istNetto != 'undefined' && istNetto == 1) {
			taxFaktor = 1;
		}

		if (typeof trueNettoWert != 'undefined' && !isNaN(trueNettoWert)) {
			console.log('trueNettoWert: ' + trueNettoWert);
			priceCalc = trueNettoWert;
		}
		
		if (typeof bulkPrice_arr != 'undefined' && bulkPrice_arr.length > 0) {
			bulkPrice_arr.each(function(index) {
				if (!$(this).hasClass('buyedMost')) {
					bulk_qty = parseFloat($(this).find('td:first-child').html());
					tmpPrice1 = $(this).find('.bulk-price1').text().trim().replace('(','').replace(')','');
					console.log('bulk netto: ' + tmpPrice1);
					if (trueNetto == 1) {
						tmpPriceCalc1 = parseFloat($(this).find('.bulk-price1').data('true-netto-wert'));
					}
					tmpPrice = $(this).find('.bulk-price').text().trim();
					if (qty >= bulk_qty) {
						price1 = tmpPrice1;
						price = tmpPrice;
						priceCalc = tmpPriceCalc1;
						priceCalc1 = tmpPriceCalc1;
						$(cssbulkprice + ' table > tbody tr').removeClass('set');
						$(this).addClass('set');
					}
					console.log(index + ' - ' + qty + ' - ' + bulk_qty + ' - ' + price + ' - ' + price1);	
				}	
			});
			console.log('Bulk Price found: ' + price + ' (' + price1 + ')');
		}
		price_arr = price.split(" ");
		price_arr1 = price1.split(" ");
		if (price_arr[0].charAt(price_arr[0].length-3) == ',') {
			console.log('Komma gefunden');
			price = price_arr[0].replace('.','').replace(',','.');
			price1 = price_arr1[0].replace('.','').replace(',','.');
		} else {
			if (!isNumeric(price_arr[0].charAt(0))) {
				pricePrefix = price_arr[0].charAt(0);
				price_arr[1] = '';
				price_arr1[1] = '';
			}
			price = price_arr[0].replace(',','').replace(price_arr[0].charAt(0),'');
			price1 = price_arr1[0].replace(',','').replace(price_arr[0].charAt(0),'');
		}

		console.log('Price: ' + price);
		console.log('Price1: ' + price1);
		console.log('PricePrefix: ' + pricePrefix);

		price = parseFloat(price);
		price1 = parseFloat(price1);
		tmpPrice = price;
		tmpPrice1 = price1;
		if (typeof istNetto != 'undefined' && trueNetto == 1) {
			if (priceCalc == null) {
				priceCalc = Math.round((tmpPrice / taxFaktor) * 100,4) / 100;
				priceCalc1 = Math.round((tmpPrice1) * 100,4) / 100;
			}
			console.log('Netto: ' + priceCalc);
			console.log('Brutto: ' + priceCalc1);
			gesamtpreis = priceCalc * qty;
			gesamtpreis1 = priceCalc1 * qty;
			console.log('Gesamtpreis Netto: ' + gesamtpreis);
			console.log('Gesamtpreis Brutto: ' + gesamtpreis1);
			gesamtpreis = gesamtpreis * taxFaktor;	
			gesamtpreis1 = gesamtpreis1;	
			gesamtpreis = Math.round(gesamtpreis * 100,4) / 100;
			gesamtpreis1 = Math.round(gesamtpreis1 * 100,4) / 100;
		} else {
			priceCalc = tmpPrice;
			priceCalc1 = tmpPrice1;
			console.log('Brutto: ' + priceCalc);
			console.log('Netto: ' + priceCalc1);
			gesamtpreis = priceCalc * qty;
			gesamtpreis1 = priceCalc1 * qty;
			gesamtpreis = Math.round(gesamtpreis * 100,4) / 100;
			gesamtpreis1 = Math.round(gesamtpreis1 * 100,4) / 100;
		}
		success = gesamtpreis;
		gesamtpreis = gesamtpreis.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 });
		gesamtpreis1 = gesamtpreis1.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 });
		priceString = pricePrefix + price.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 }) + " " + price_arr[1];
		priceString1 = pricePrefix + price1.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 }) + " " + price_arr1[1];
		gesamtpreisString = pricePrefix + gesamtpreis + " " + price_arr[1];
		gesamtpreisString1 = pricePrefix + gesamtpreis1 + " " + price_arr1[1];
		$(document).find('#preisberechnung .preis .main').html(priceString);
		$(document).find('#preisberechnung .preis .small').html('(' + priceString1 + ')');
		$(document).find(cssprice1).html('(' + priceString1 + ' ' + price_arr1[1] + ')');
		$(document).find('#preisberechnung .gesamtpreis .main').html(gesamtpreisString);
		$(document).find('#preisberechnung .gesamtpreis .small').html('(' + gesamtpreisString1 + ')');
		$(document).find(cssprice).html(priceString);
		$(document).find(cssprice1).html('(' + priceString1 + ' ' + textBretto + ')');
		if (isNaN(success)) {
			console.log('kein Gesamtpreis! ' + success);
			return false;
		}
		return true;
	}
} 

// bos aufbauen
function initGesamtpreis() {
	window.setTimeout(function() {
		console.log('Gesamtpreis - init');
		var livecalc = $(document).find('#buy_form').data('livecalc');

		if (livecalc === 1) {
			const vw = Math.max(document.documentElement.clientWidth || 0, window.innerWidth || 0);
			var boxGesamtpreis = $(document).find('#preisberechnung'),
				cssqty = $(document).find('#buy_form').data('css-qty'),
				oQTY = $(document).find('#quantity'),
				qty_wrapper = oQTY.parent(),
				//offset = ($(document).find('#add-to-cart').outerWidth() - $(document).find('#add-to-cart #quantity-grp').outerWidth()) / 2,
				offset = (qty_wrapper.outerWidth()) / 2,
				minusButton = $(document).find('#buy_form ' + cssqty + ' .fa-plus').outerWidth(),
				pfeil = 0,
				preis = 0,
				gesamtpreis = 0,
				symbolTimes = 0,
				symbolGleich = 0;

			if (typeof minusButton === 'undefined') {
				console.log('minusButton neu berechnen')
				minusButton = $(document).find('#buy_form ' + cssqty + ' [data-spinner-button="up"]').outerWidth();
			}
			//console.log(boxGesamtpreis);
			pfeil = oQTY.outerWidth() + offset + minusButton - 45;
			if (vw <768)
				pfeil = pfeil / 3;
			symbolTimes = $(document).find('#preisberechnung .symbol-times').outerWidth();
			//preis = $('#preisberechnung .preis').outerWidth();
			preisDimenstions = $(document).find("#preisberechnung .preis").getRealDimensions;
			preis = preisDimenstions.width;
			symbolGleich = $(document).find('#preisberechnung .symbol-gleich').outerWidth();

			console.log('#add-to-cart - #quantity-grp - minusbutton - pfeil - x-symbol - preis - istgleich');
			console.log($(document).find('#add-to-cart').outerWidth() + ' - ' + qty_wrapper.outerWidth() + ' - ' + minusButton + ' - ' + pfeil + ' - ' + Math.abs(symbolTimes) + ' - ' +  preis + ' - ' +  Math.abs(symbolGleich));
			gesamtpreis = $(document).find('#add-to-cart').outerWidth() - minusButton - pfeil - Math.abs(symbolTimes) - preis - Math.abs(symbolGleich) - (offset) - 15;

			$(document).find('#preisberechnung .pfeiltext').outerWidth(pfeil);
			$(document).find('#preisberechnung .preis').outerWidth(preis);
			$(document).find('#preisberechnung .gesamtpreis').outerWidth(gesamtpreis);
			$(document).find('#product-offer .price_wrapper .price_label.pricestarting').hide();
			//console.log('test');
			if (calcGesamtpreis()) {
				console.log('Box fade in');
				boxGesamtpreis.fadeIn('slow');
			}
			//console.log('test');
		}
	}, 100);
}

//////  bulk price rows
var cssbulkprice = $(document).find('#buy_form').data('css-bulkprice'),
	cssqty = $(document).find('#buy_form').data('css-qty'),
	oQTY = $(document).find('#quantity'),
	bulks = cssbulkprice + ' table > tbody tr';
console.log('Bulks Prices:');
console.log(bulks);
$(document).on('click touch', bulks, function() {
	var quantity = parseInt($(this).find('td:first-child').text());
	if (!isNaN(quantity)) {
		oQTY.val(quantity);
		$(document).find(bulks).removeClass('set');
		$(this).addClass('set');
		calcGesamtpreis();
	}
});

///// Plus Minus Buttons
$(document).on('click touch', '#buy_form ' + cssqty + ' button[data-count-up], [data-spinner-button="up"], .btn.qty-add', function(e) {
	e.stopImmediatePropagation();
	console.log('klick plus');
	var delay = 500;
	setTimeout(function() {
		calcGesamtpreis();
	}, delay);
	//updateQuatity('plus'); // Funktion im Nova Template schon drin
});
$(document).on('click touch', '#buy_form ' + cssqty + ' button[data-count-down], [data-spinner-button="down"], .btn.qty-sub', function(e) {
	e.stopImmediatePropagation();
	console.log('klick minus');
	var delay = 500;
	setTimeout(function() {
		calcGesamtpreis();
	}, delay);
	//updateQuatity('minus'); // Funktion im Nova Template schon drin
});
$(document).on('change keyup', '#product-configurator input, #product-configurator select', function(e) {
	console.log('Konfigurator geändert');
	var delay = 500;
	setTimeout(function() {
		calcGesamtpreis();
	}, delay);
	//updateQuatity('minus'); // Funktion im Nova Template schon drin
});

function isNumeric(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

// Funktion im Nova Template schon drin
/*function updateQuatity(plusminus) {
	var min = parseInt($('#quantity').data('min'));
	var int = parseInt($('#quantity').data('int'));
	var quantity = parseInt($('#quantity').val());
	var newquantity = quantity;
	var addition = 1;
	
	if (!isNaN(min) && int > 1) {
		addition = int;
	}
	
	if (min == 0 || isNaN(min)) {
		min = 1;
	}
	
	if (plusminus == 'minus') {
		addition = addition*-1;
		console.log('neagive Addition');
	}
	
	newquantity = newquantity + (addition);

	if (newquantity < min) {
		newquantity = min;
		console.log('Korrektur, QTY darf nicht unter ' + min + ' sein!');
		errorMindestabnahme();
	} else {
		$('#quantity').val(newquantity);
		calcGesamtpreis();
	}
	//console.log('quantity:  ' + quantity + '; min:  ' + min + '; int: ' + int + '; addition: ' + addition + '; newquantity: ' + newquantity);
	
}
*/
/*** Artikelliste ***/


